Index: /trunk/sources/HeuristicLab.Problems.Scheduling/3.3/Decoders/PRVDecoder.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.Scheduling/3.3/Decoders/PRVDecoder.cs	(revision 8886)
+++ /trunk/sources/HeuristicLab.Problems.Scheduling/3.3/Decoders/PRVDecoder.cs	(revision 8887)
@@ -20,4 +20,5 @@
 #endregion
 
+using System;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
@@ -31,5 +32,6 @@
   [Item("JobSequencingMatrixDecoder", "Applies the GifflerThompson algorithm to create an active schedule from a JobSequencing Matrix.")]
   [StorableClass]
-  public class PRVDecoder : ScheduleDecoder<PRVEncoding>, IStochasticOperator, IJSSPOperator {
+  public class PRVDecoder : ScheduleDecoder, IStochasticOperator, IJSSPOperator {
+
     public ILookupParameter<IRandom> RandomParameter {
       get { return (LookupParameter<IRandom>)Parameters["Random"]; }
@@ -38,12 +40,4 @@
       get { return (LookupParameter<ItemList<Job>>)Parameters["JobData"]; }
     }
-
-    #region Private Members
-    [Storable]
-    private Schedule resultingSchedule;
-
-    [Storable]
-    private ItemList<Job> jobs;
-    #endregion
 
     #region Priority Rules
@@ -55,9 +49,9 @@
 
     //earliest start time
-    private Task ESTRule(ItemList<Task> tasks) {
+    private Task ESTRule(ItemList<Task> tasks, Schedule schedule) {
       Task currentResult = RandomRule(tasks);
       double currentEST = double.MaxValue;
       foreach (Task t in tasks) {
-        double est = GTAlgorithmUtils.ComputeEarliestStartTime(t, resultingSchedule);
+        double est = GTAlgorithmUtils.ComputeEarliestStartTime(t, schedule);
         if (est < currentEST) {
           currentEST = est;
@@ -89,5 +83,5 @@
 
     //most work remaining
-    private Task MWRRule(ItemList<Task> tasks) {
+    private Task MWRRule(ItemList<Task> tasks, ItemList<Job> jobs) {
       Task currentResult = RandomRule(tasks);
       double currentLargestRemainingProcessingTime = 0;
@@ -107,5 +101,5 @@
 
     //least work remaining
-    private Task LWRRule(ItemList<Task> tasks) {
+    private Task LWRRule(ItemList<Task> tasks, ItemList<Job> jobs) {
       Task currentResult = RandomRule(tasks);
       double currentSmallestRemainingProcessingTime = double.MaxValue;
@@ -125,5 +119,5 @@
 
     //most operations remaining
-    private Task MORRule(ItemList<Task> tasks) {
+    private Task MORRule(ItemList<Task> tasks, ItemList<Job> jobs) {
       Task currentResult = RandomRule(tasks);
       int currentLargestNrOfRemainingTasks = 0;
@@ -143,5 +137,5 @@
 
     //least operationsremaining
-    private Task LORRule(ItemList<Task> tasks) {
+    private Task LORRule(ItemList<Task> tasks, ItemList<Job> jobs) {
       Task currentResult = RandomRule(tasks);
       int currentSmallestNrOfRemainingTasks = int.MaxValue;
@@ -176,12 +170,5 @@
     [StorableConstructor]
     protected PRVDecoder(bool deserializing) : base(deserializing) { }
-    protected PRVDecoder(PRVDecoder original, Cloner cloner)
-      : base(original, cloner) {
-      this.resultingSchedule = cloner.Clone(original.resultingSchedule);
-    }
-    public override IDeepCloneable Clone(Cloner cloner) {
-      return new PRVDecoder(this, cloner);
-    }
-
+    protected PRVDecoder(PRVDecoder original, Cloner cloner) : base(original, cloner) { }
     public PRVDecoder()
       : base() {
@@ -191,5 +178,9 @@
     }
 
-    private Task SelectTaskFromConflictSet(ItemList<Task> conflictSet, int ruleIndex, int nrOfRules) {
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new PRVDecoder(this, cloner);
+    }
+
+    private Task SelectTaskFromConflictSet(ItemList<Task> conflictSet, int ruleIndex, int nrOfRules, Schedule schedule, ItemList<Job> jobs) {
       if (conflictSet.Count == 1)
         return conflictSet[0];
@@ -198,11 +189,11 @@
       switch (ruleIndex) {
         case 0: return FILORule(conflictSet);
-        case 1: return ESTRule(conflictSet);
+        case 1: return ESTRule(conflictSet, schedule);
         case 2: return SPTRule(conflictSet);
         case 3: return LPTRule(conflictSet);
-        case 4: return MWRRule(conflictSet);
-        case 5: return LWRRule(conflictSet);
-        case 6: return MORRule(conflictSet);
-        case 7: return LORRule(conflictSet);
+        case 4: return MWRRule(conflictSet, jobs);
+        case 5: return LWRRule(conflictSet, jobs);
+        case 6: return MORRule(conflictSet, jobs);
+        case 7: return LORRule(conflictSet, jobs);
         case 8: return FIFORule(conflictSet);
         case 9: return RandomRule(conflictSet);
@@ -211,7 +202,10 @@
     }
 
-    public override Schedule CreateScheduleFromEncoding(PRVEncoding solution) {
-      jobs = (ItemList<Job>)JobDataParameter.ActualValue.Clone();
-      resultingSchedule = new Schedule(jobs[0].Tasks.Count);
+    public override Schedule CreateScheduleFromEncoding(IScheduleEncoding encoding) {
+      var solution = encoding as PRVEncoding;
+      if (solution == null) throw new InvalidOperationException("Encoding is not of type PWREncoding");
+
+      var jobs = (ItemList<Job>)JobDataParameter.ActualValue.Clone();
+      var resultingSchedule = new Schedule(jobs[0].Tasks.Count);
 
       //Reset scheduled tasks in result
@@ -235,5 +229,5 @@
         //STEP 3 - Select an operation from the conflict set (various methods depending on how the algorithm should work..)
         //Task selectedTask = SelectTaskFromConflictSet(conflictSet, solution.PriorityRulesVector [currentDecisionIndex++], solution.NrOfRules.Value);
-        Task selectedTask = SelectTaskFromConflictSet(conflictSet, solution.PriorityRulesVector[minimal.JobNr], solution.NrOfRules.Value);
+        Task selectedTask = SelectTaskFromConflictSet(conflictSet, solution.PriorityRulesVector[minimal.JobNr], solution.NrOfRules.Value, resultingSchedule, jobs);
 
         //STEP 4 - Adding the selected operation to the current schedule
@@ -248,8 +242,4 @@
       return resultingSchedule;
     }
-
-    public override IOperation Apply() {
-      return base.Apply();
-    }
   }
 }
Index: /trunk/sources/HeuristicLab.Problems.Scheduling/3.3/Decoders/PWRDecoder.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.Scheduling/3.3/Decoders/PWRDecoder.cs	(revision 8886)
+++ /trunk/sources/HeuristicLab.Problems.Scheduling/3.3/Decoders/PWRDecoder.cs	(revision 8887)
@@ -20,4 +20,5 @@
 #endregion
 
+using System;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
@@ -31,5 +32,6 @@
   [Item("PWRDecoder", "An item used to convert a PWR-individual into a generalized schedule.")]
   [StorableClass]
-  public class PWRDecoder : ScheduleDecoder<PWREncoding>, IStochasticOperator, IJSSPOperator {
+  public class PWRDecoder : ScheduleDecoder, IStochasticOperator, IJSSPOperator {
+
     public ILookupParameter<IRandom> RandomParameter {
       get { return (LookupParameter<IRandom>)Parameters["Random"]; }
@@ -41,11 +43,5 @@
     [StorableConstructor]
     protected PWRDecoder(bool deserializing) : base(deserializing) { }
-    protected PWRDecoder(PWRDecoder original, Cloner cloner)
-      : base(original, cloner) {
-    }
-    public override IDeepCloneable Clone(Cloner cloner) {
-      return new PWRDecoder(this, cloner);
-    }
-
+    protected PWRDecoder(PWRDecoder original, Cloner cloner) : base(original, cloner) { }
     public PWRDecoder()
       : base() {
@@ -55,7 +51,14 @@
     }
 
-    public override Schedule CreateScheduleFromEncoding(PWREncoding solution) {
-      ItemList<Job> jobs = (ItemList<Job>)JobDataParameter.ActualValue.Clone();
-      Schedule resultingSchedule = new Schedule(jobs[0].Tasks.Count);
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new PWRDecoder(this, cloner);
+    }
+
+    public override Schedule CreateScheduleFromEncoding(IScheduleEncoding encoding) {
+      var solution = encoding as PWREncoding;
+      if (solution == null) throw new InvalidOperationException("Encoding is not of type PWREncoding");
+
+      var jobs = (ItemList<Job>)JobDataParameter.ActualValue.Clone();
+      var resultingSchedule = new Schedule(jobs[0].Tasks.Count);
       foreach (int jobNr in solution.PermutationWithRepetition) {
         int i = 0;
@@ -68,8 +71,4 @@
       return resultingSchedule;
     }
-
-    public override IOperation Apply() {
-      return base.Apply();
-    }
   }
 }
Index: /trunk/sources/HeuristicLab.Problems.Scheduling/3.3/Decoders/ScheduleDecoder.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.Scheduling/3.3/Decoders/ScheduleDecoder.cs	(revision 8887)
+++ /trunk/sources/HeuristicLab.Problems.Scheduling/3.3/Decoders/ScheduleDecoder.cs	(revision 8887)
@@ -0,0 +1,58 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Encodings.ScheduleEncoding;
+using HeuristicLab.Operators;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Problems.Scheduling {
+  [Item("ScheduleDecoder", "A schedule decoder translates a respresentation into an actual schedule.")]
+  [StorableClass]
+  public abstract class ScheduleDecoder : SingleSuccessorOperator, IScheduleDecoder {
+
+    public ILookupParameter<IScheduleEncoding> ScheduleEncodingParameter {
+      get { return (ILookupParameter<IScheduleEncoding>)Parameters["ScheduleEncoding"]; }
+    }
+    public ILookupParameter<Schedule> ScheduleParameter {
+      get { return (ILookupParameter<Schedule>)Parameters["Schedule"]; }
+    }
+
+    [StorableConstructor]
+    protected ScheduleDecoder(bool deserializing) : base(deserializing) { }
+    protected ScheduleDecoder(ScheduleDecoder original, Cloner cloner) : base(original, cloner) { }
+    public ScheduleDecoder()
+      : base() {
+      Parameters.Add(new LookupParameter<IScheduleEncoding>("ScheduleEncoding", "The new scheduling solution represented as encoding."));
+      Parameters.Add(new LookupParameter<Schedule>("Schedule", "The decoded scheduling solution represented as generalized schedule."));
+    }
+
+    public abstract Schedule CreateScheduleFromEncoding(IScheduleEncoding solution);
+
+    public override IOperation Apply() {
+      Schedule result = CreateScheduleFromEncoding(ScheduleEncodingParameter.ActualValue);
+      ScheduleParameter.ActualValue = result;
+      return base.Apply();
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.Problems.Scheduling/3.3/Evaluators/MakespanEvaluator.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.Scheduling/3.3/Evaluators/MakespanEvaluator.cs	(revision 8886)
+++ /trunk/sources/HeuristicLab.Problems.Scheduling/3.3/Evaluators/MakespanEvaluator.cs	(revision 8887)
@@ -30,15 +30,17 @@
   [Item("Makespan Evaluator", "Represents an evaluator using the maximum makespan of a schedule.")]
   [StorableClass]
-  public class MakespanEvaluator : SchedulingEvaluator {
+  public class MakespanEvaluator : ScheduleEvaluator {
+
     [StorableConstructor]
     protected MakespanEvaluator(bool deserializing) : base(deserializing) { }
-    protected MakespanEvaluator(MakespanEvaluator original, Cloner cloner)
-      : base(original, cloner) {
+    protected MakespanEvaluator(MakespanEvaluator original, Cloner cloner) : base(original, cloner) {}
+    public MakespanEvaluator()
+      : base() {
+      QualityParameter.ActualName = "Makespan";
     }
+
     public override IDeepCloneable Clone(Cloner cloner) {
       return new MakespanEvaluator(this, cloner);
     }
-
-    public MakespanEvaluator() : base() { }
 
     public static double GetMakespan(Schedule schedule) {
@@ -46,10 +48,6 @@
     }
 
-    protected override DoubleValue Evaluate(Schedule schedule) {
-      return new DoubleValue(GetMakespan(schedule));
-    }
-
-    public override IOperation Apply() {
-      return base.Apply();
+    protected override double Evaluate(Schedule schedule) {
+      return GetMakespan(schedule);
     }
   }
Index: /trunk/sources/HeuristicLab.Problems.Scheduling/3.3/Evaluators/MeanTardinessEvaluator.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.Scheduling/3.3/Evaluators/MeanTardinessEvaluator.cs	(revision 8886)
+++ /trunk/sources/HeuristicLab.Problems.Scheduling/3.3/Evaluators/MeanTardinessEvaluator.cs	(revision 8887)
@@ -32,5 +32,5 @@
   [Item("Mean tardiness Evaluator", "Represents an evaluator using the mean tardiness of a schedule.")]
   [StorableClass]
-  public class MeanTardinessEvaluator : SchedulingEvaluator, IJSSPOperator {
+  public class MeanTardinessEvaluator : ScheduleEvaluator, IJSSPOperator {
 
     [StorableConstructor]
@@ -50,4 +50,5 @@
       : base() {
       Parameters.Add(new LookupParameter<ItemList<Job>>("JobData", "Jobdata defining the precedence relationships and the duration of the tasks in this JSSP-Instance."));
+      QualityParameter.ActualName = "MeanTardiness";
     }
 
@@ -58,6 +59,6 @@
     }
 
-    protected override DoubleValue Evaluate(Schedule schedule) {
-      return new DoubleValue(GetMeanTardiness(schedule, JobDataParameter.ActualValue));
+    protected override double Evaluate(Schedule schedule) {
+      return GetMeanTardiness(schedule, JobDataParameter.ActualValue);
     }
   }
Index: /trunk/sources/HeuristicLab.Problems.Scheduling/3.3/Evaluators/ScheduleEvaluator.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.Scheduling/3.3/Evaluators/ScheduleEvaluator.cs	(revision 8887)
+++ /trunk/sources/HeuristicLab.Problems.Scheduling/3.3/Evaluators/ScheduleEvaluator.cs	(revision 8887)
@@ -0,0 +1,58 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Encodings.ScheduleEncoding;
+using HeuristicLab.Operators;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Problems.Scheduling {
+  [Item("Schedule Evaluator", "Represents a base class for schedule evaluators.")]
+  [StorableClass]
+  public abstract class ScheduleEvaluator : SingleSuccessorOperator, IScheduleEvaluator {
+
+    public ILookupParameter<DoubleValue> QualityParameter {
+      get { return (ILookupParameter<DoubleValue>)Parameters["Quality"]; }
+    }
+    public ILookupParameter<Schedule> ScheduleParameter {
+      get { return (ILookupParameter<Schedule>)Parameters["Schedule"]; }
+    }
+
+    [StorableConstructor]
+    protected ScheduleEvaluator(bool deserializing) : base(deserializing) { }
+    protected ScheduleEvaluator(ScheduleEvaluator original, Cloner cloner) : base(original, cloner) { }
+    protected ScheduleEvaluator()
+      : base() {
+      Parameters.Add(new LookupParameter<DoubleValue>("Quality", "The quality value aka fitness value of the solution."));
+      Parameters.Add(new LookupParameter<Schedule>("Schedule", "The decoded scheduling solution represented as generalized schedule."));
+    }
+
+    protected abstract double Evaluate(Schedule schedule);
+
+    public override IOperation Apply() {
+      QualityParameter.ActualValue = new DoubleValue(Evaluate(ScheduleParameter.ActualValue));
+      return base.Apply();
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.Problems.Scheduling/3.3/Evaluators/SchedulingEvaluator.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.Scheduling/3.3/Evaluators/SchedulingEvaluator.cs	(revision 8886)
+++ /trunk/sources/HeuristicLab.Problems.Scheduling/3.3/Evaluators/SchedulingEvaluator.cs	(revision 8887)
@@ -20,4 +20,5 @@
 #endregion
 
+using System;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
@@ -28,43 +29,50 @@
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
+namespace HeuristicLab.Problems.Scheduling {
+  [Item("SchedulingEvaluator", "First applies the decoder operator to obtain a schedule from an encoding and then applies the evaluator to obtain a quality.")]
+  [StorableClass]
+  public class SchedulingEvaluator : SingleSuccessorOperator, ISchedulingEvaluator {
 
-namespace HeuristicLab.Problems.Scheduling {
-  [Item("Scheduling Evaluator", "Represents a evaluator class for standard scheduling problems.")]
-  [StorableClass]
-  public abstract class SchedulingEvaluator : SingleSuccessorOperator, IScheduleEvaluator {
+    public IValueLookupParameter<IScheduleDecoder> ScheduleDecoderParameter {
+      get { return (IValueLookupParameter<IScheduleDecoder>) Parameters["ScheduleDecoder"]; }
+    }
+    ILookupParameter<IScheduleDecoder> ISchedulingEvaluator.ScheduleDecoderParameter {
+      get { return ScheduleDecoderParameter; }
+    }
+    public IValueLookupParameter<IScheduleEvaluator> ScheduleEvaluatorParameter {
+      get { return (IValueLookupParameter<IScheduleEvaluator>) Parameters["ScheduleEvaluator"]; }
+    }
+    ILookupParameter<IScheduleEvaluator> ISchedulingEvaluator.ScheduleEvaluatorParameter {
+      get { return ScheduleEvaluatorParameter; }
+    }
+    public ILookupParameter<DoubleValue> QualityParameter {
+      get { return (ILookupParameter<DoubleValue>)Parameters["Quality"]; }
+    }
+
     [StorableConstructor]
     protected SchedulingEvaluator(bool deserializing) : base(deserializing) { }
-    protected SchedulingEvaluator(SchedulingEvaluator original, Cloner cloner)
-      : base(original, cloner) {
+    protected SchedulingEvaluator(SchedulingEvaluator original, Cloner cloner) : base(original, cloner) { }
+    public SchedulingEvaluator()
+      : base() {
+      Parameters.Add(new ValueLookupParameter<IScheduleDecoder>("ScheduleDecoder", "The decoding operator that is used to calculate a schedule from the used representation."));
+      Parameters.Add(new ValueLookupParameter<IScheduleEvaluator>("ScheduleEvaluator", "The actual schedule evaluation operator."));
+      Parameters.Add(new LookupParameter<DoubleValue>("Quality", "The quality value aka fitness value of the solution."));
+      QualityParameter.Hidden = true;
     }
 
-    public ILookupParameter<IRandom> RandomParameter {
-      get { return (LookupParameter<IRandom>)Parameters["Random"]; }
-    }
-    public ILookupParameter<DoubleValue> QualityParameter {
-      get {
-        if (Parameters.ContainsKey("Quality"))
-          return (ILookupParameter<DoubleValue>)Parameters["Quality"];
-        else
-          return null;
-      }
-    }
-    public ILookupParameter<Schedule> ScheduleParameter {
-      get { return (ILookupParameter<Schedule>)Parameters["Schedule"]; }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new SchedulingEvaluator(this, cloner);
     }
 
-    public SchedulingEvaluator()
-      : base() {
-      Parameters.Add(new LookupParameter<DoubleValue>("Quality", "The quality value aka fitness value of the solution."));
-      Parameters.Add(new LookupParameter<Schedule>("Schedule", "The decoded scheduling solution represented as generalized schedule."));
-      Parameters.Add(new LookupParameter<IRandom>("Random", "The pseudo random number generator."));
-    }
+    public override IOperation Apply() {
+      var decoder = ScheduleDecoderParameter.ActualValue;
+      var evaluator = ScheduleEvaluatorParameter.ActualValue;
+      if (evaluator == null) throw new InvalidOperationException("A ScheduleEvaluator could not be found.");
 
-    protected abstract DoubleValue Evaluate(Schedule schedule);
-
-    public override IOperation Apply() {
-      Schedule schedule = ScheduleParameter.ActualValue;
-      QualityParameter.ActualValue = Evaluate(schedule);
-      return base.Apply();
+      var operations = new OperationCollection(base.Apply());
+      operations.Insert(0, ExecutionContext.CreateChildOperation(evaluator));
+      if (decoder != null) // decode before evaluating
+        operations.Insert(0, ExecutionContext.CreateChildOperation(decoder));
+      return operations;
     }
   }
Index: /trunk/sources/HeuristicLab.Problems.Scheduling/3.3/HeuristicLab.Problems.Scheduling-3.3.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Problems.Scheduling/3.3/HeuristicLab.Problems.Scheduling-3.3.csproj	(revision 8886)
+++ /trunk/sources/HeuristicLab.Problems.Scheduling/3.3/HeuristicLab.Problems.Scheduling-3.3.csproj	(revision 8887)
@@ -107,15 +107,21 @@
     <Compile Include="Analyzers\BestSchedulingSolutionAnalyzer.cs" />
     <Compile Include="Analyzers\SchedulingAnalyzer.cs" />
+    <Compile Include="Decoders\JSMForcingStrategy.cs" />
     <Compile Include="Decoders\JSMDecoder.cs" />
+    <Compile Include="Decoders\JSMDecodingErrorPolicy.cs" />
     <Compile Include="Decoders\JSMDecodingErrorPolicyTypes.cs" />
     <Compile Include="Decoders\JSMForcingStrategyTypes.cs" />
     <Compile Include="Decoders\PRVDecoder.cs" />
     <Compile Include="Decoders\PWRDecoder.cs" />
+    <Compile Include="Decoders\ScheduleDecoder.cs" />
     <Compile Include="Evaluators\MeanTardinessEvaluator.cs" />
     <Compile Include="Evaluators\MakespanEvaluator.cs" />
+    <Compile Include="Evaluators\ScheduleEvaluator.cs" />
+    <Compile Include="Interfaces\IJSSPOperator.cs" />
+    <Compile Include="Interfaces\IScheduleDecoder.cs" />
+    <Compile Include="Interfaces\ISchedulingEvaluator.cs" />
+    <Compile Include="Interfaces\IScheduleEvaluator.cs" />
+    <Compile Include="JobShopSchedulingProblem.cs" />
     <Compile Include="Evaluators\SchedulingEvaluator.cs" />
-    <Compile Include="Interfaces\IJSSPOperator.cs" />
-    <Compile Include="JobShopSchedulingProblem.cs" />
-    <Compile Include="Evaluators\SchedulingEvaluationAlgorithm.cs" />
     <Compile Include="SchedulingProblem.cs" />
     <Compile Include="Plugin.cs" />
Index: /trunk/sources/HeuristicLab.Problems.Scheduling/3.3/Interfaces/IJSSPOperator.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.Scheduling/3.3/Interfaces/IJSSPOperator.cs	(revision 8886)
+++ /trunk/sources/HeuristicLab.Problems.Scheduling/3.3/Interfaces/IJSSPOperator.cs	(revision 8887)
@@ -1,3 +1,24 @@
-﻿using HeuristicLab.Core;
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Core;
 using HeuristicLab.Encodings.ScheduleEncoding;
 
Index: /trunk/sources/HeuristicLab.Problems.Scheduling/3.3/Interfaces/IScheduleDecoder.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.Scheduling/3.3/Interfaces/IScheduleDecoder.cs	(revision 8887)
+++ /trunk/sources/HeuristicLab.Problems.Scheduling/3.3/Interfaces/IScheduleDecoder.cs	(revision 8887)
@@ -0,0 +1,29 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Core;
+
+namespace HeuristicLab.Encodings.ScheduleEncoding {
+  public interface IScheduleDecoder : IOperator {
+    ILookupParameter<IScheduleEncoding> ScheduleEncodingParameter { get; }
+    ILookupParameter<Schedule> ScheduleParameter { get; }
+  }
+}
Index: /trunk/sources/HeuristicLab.Problems.Scheduling/3.3/Interfaces/IScheduleEvaluator.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.Scheduling/3.3/Interfaces/IScheduleEvaluator.cs	(revision 8887)
+++ /trunk/sources/HeuristicLab.Problems.Scheduling/3.3/Interfaces/IScheduleEvaluator.cs	(revision 8887)
@@ -0,0 +1,33 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Core;
+using HeuristicLab.Encodings.ScheduleEncoding;
+using HeuristicLab.Optimization;
+
+namespace HeuristicLab.Problems.Scheduling {
+  /// <summary>
+  /// An evaluator for a Schedule
+  /// </summary>
+  public interface IScheduleEvaluator : ISingleObjectiveEvaluator {
+    ILookupParameter<Schedule> ScheduleParameter { get; }
+  }
+}
Index: /trunk/sources/HeuristicLab.Problems.Scheduling/3.3/Interfaces/ISchedulingEvaluator.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.Scheduling/3.3/Interfaces/ISchedulingEvaluator.cs	(revision 8887)
+++ /trunk/sources/HeuristicLab.Problems.Scheduling/3.3/Interfaces/ISchedulingEvaluator.cs	(revision 8887)
@@ -0,0 +1,34 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Core;
+using HeuristicLab.Encodings.ScheduleEncoding;
+using HeuristicLab.Optimization;
+
+namespace HeuristicLab.Problems.Scheduling {
+  /// <summary>
+  /// An evaluator for a scheduling problem representation
+  /// </summary>
+  public interface ISchedulingEvaluator : ISingleObjectiveEvaluator {
+    ILookupParameter<IScheduleDecoder> ScheduleDecoderParameter { get; }
+    ILookupParameter<IScheduleEvaluator> ScheduleEvaluatorParameter { get; }
+  }
+}
